# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-104: error:
# ERROR-NOT: error:
# CHECK: {evex}	addb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x80,0xc3,0x7b]
         {evex}	addb	$123, %bl
# CHECK: {nf}	addb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x80,0xc3,0x7b]
         {nf}	addb	$123, %bl
# CHECK: addb	$123, %bl, %cl
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0x80,0xc3,0x7b]
         addb	$123, %bl, %cl
# CHECK: {nf}	addb	$123, %bl, %cl
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0x80,0xc3,0x7b]
         {nf}	addb	$123, %bl, %cl
# CHECK: {evex}	addw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x83,0xc2,0x7b]
         {evex}	addw	$123, %dx
# CHECK: {nf}	addw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x83,0xc2,0x7b]
         {nf}	addw	$123, %dx
# CHECK: addw	$123, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x83,0xc2,0x7b]
         addw	$123, %dx, %ax
# CHECK: {nf}	addw	$123, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x83,0xc2,0x7b]
         {nf}	addw	$123, %dx, %ax
# CHECK: {evex}	addl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x83,0xc1,0x7b]
         {evex}	addl	$123, %ecx
# CHECK: {nf}	addl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x83,0xc1,0x7b]
         {nf}	addl	$123, %ecx
# CHECK: addl	$123, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x83,0xc1,0x7b]
         addl	$123, %ecx, %edx
# CHECK: {nf}	addl	$123, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x83,0xc1,0x7b]
         {nf}	addl	$123, %ecx, %edx
# CHECK: {evex}	addq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xc1,0x7b]
         {evex}	addq	$123, %r9
# CHECK: {nf}	addq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xc1,0x7b]
         {nf}	addq	$123, %r9
# CHECK: addq	$123, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x83,0xc1,0x7b]
         addq	$123, %r9, %r15
# CHECK: {nf}	addq	$123, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x83,0xc1,0x7b]
         {nf}	addq	$123, %r9, %r15
# CHECK: {evex}	addb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x80,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	addb	$123, 291(%r8,%rax,4)
# CHECK: {nf}	addb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x80,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	addb	$123, 291(%r8,%rax,4)
# CHECK: addb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0x80,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         addb	$123, 291(%r8,%rax,4), %bl
# CHECK: {nf}	addb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0x80,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	addb	$123, 291(%r8,%rax,4), %bl
# CHECK: {evex}	addw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	addw	$123, 291(%r8,%rax,4)
# CHECK: {nf}	addw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	addw	$123, 291(%r8,%rax,4)
# CHECK: addw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         addw	$123, 291(%r8,%rax,4), %dx
# CHECK: {nf}	addw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	addw	$123, 291(%r8,%rax,4), %dx
# CHECK: {evex}	addl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	addl	$123, 291(%r8,%rax,4)
# CHECK: {nf}	addl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	addl	$123, 291(%r8,%rax,4)
# CHECK: addl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         addl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	addl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	addl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	addq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	addq	$123, 291(%r8,%rax,4)
# CHECK: {nf}	addq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	addq	$123, 291(%r8,%rax,4)
# CHECK: addq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         addq	$123, 291(%r8,%rax,4), %r9
# CHECK: {nf}	addq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x83,0x84,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	addq	$123, 291(%r8,%rax,4), %r9
# CHECK: {evex}	addw	$1234, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x81,0xc2,0xd2,0x04]
         {evex}	addw	$1234, %dx
# CHECK: {nf}	addw	$1234, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x81,0xc2,0xd2,0x04]
         {nf}	addw	$1234, %dx
# CHECK: addw	$1234, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x81,0xc2,0xd2,0x04]
         addw	$1234, %dx, %ax
# CHECK: {nf}	addw	$1234, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x81,0xc2,0xd2,0x04]
         {nf}	addw	$1234, %dx, %ax
# CHECK: {evex}	addw	$1234, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {evex}	addw	$1234, 291(%r8,%rax,4)
# CHECK: {nf}	addw	$1234, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	addw	$1234, 291(%r8,%rax,4)
# CHECK: addw	$1234, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         addw	$1234, 291(%r8,%rax,4), %dx
# CHECK: {nf}	addw	$1234, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	addw	$1234, 291(%r8,%rax,4), %dx
# CHECK: {evex}	addl	$123456, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x81,0xc1,0x40,0xe2,0x01,0x00]
         {evex}	addl	$123456, %ecx
# CHECK: {nf}	addl	$123456, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x81,0xc1,0x40,0xe2,0x01,0x00]
         {nf}	addl	$123456, %ecx
# CHECK: addl	$123456, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x81,0xc1,0x40,0xe2,0x01,0x00]
         addl	$123456, %ecx, %edx
# CHECK: {nf}	addl	$123456, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x81,0xc1,0x40,0xe2,0x01,0x00]
         {nf}	addl	$123456, %ecx, %edx
# CHECK: {evex}	addq	$123456, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xc1,0x40,0xe2,0x01,0x00]
         {evex}	addq	$123456, %r9
# CHECK: {nf}	addq	$123456, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xc1,0x40,0xe2,0x01,0x00]
         {nf}	addq	$123456, %r9
# CHECK: addq	$123456, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x81,0xc1,0x40,0xe2,0x01,0x00]
         addq	$123456, %r9, %r15
# CHECK: {nf}	addq	$123456, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x81,0xc1,0x40,0xe2,0x01,0x00]
         {nf}	addq	$123456, %r9, %r15
# CHECK: {evex}	addl	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	addl	$123456, 291(%r8,%rax,4)
# CHECK: {nf}	addl	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	addl	$123456, 291(%r8,%rax,4)
# CHECK: addl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         addl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	addl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	addl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	addq	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	addq	$123456, 291(%r8,%rax,4)
# CHECK: {nf}	addq	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	addq	$123456, 291(%r8,%rax,4)
# CHECK: addq	$123456, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         addq	$123456, 291(%r8,%rax,4), %r9
# CHECK: {nf}	addq	$123456, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x81,0x84,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	addq	$123456, 291(%r8,%rax,4), %r9
# CHECK: {evex}	addb	%bl, %cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x00,0xd9]
         {evex}	addb	%bl, %cl
# CHECK: {nf}	addb	%bl, %cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x00,0xd9]
         {nf}	addb	%bl, %cl
# CHECK: addb	%bl, %cl, %r8b
# CHECK: encoding: [0x62,0xf4,0x3c,0x18,0x00,0xd9]
         addb	%bl, %cl, %r8b
# CHECK: {nf}	addb	%bl, %cl, %r8b
# CHECK: encoding: [0x62,0xf4,0x3c,0x1c,0x00,0xd9]
         {nf}	addb	%bl, %cl, %r8b
# CHECK: {evex}	addb	%bl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x00,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	addb	%bl, 291(%r8,%rax,4)
# CHECK: {nf}	addb	%bl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x00,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addb	%bl, 291(%r8,%rax,4)
# CHECK: addb	%bl, 291(%r8,%rax,4), %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x00,0x9c,0x80,0x23,0x01,0x00,0x00]
         addb	%bl, 291(%r8,%rax,4), %cl
# CHECK: {nf}	addb	%bl, 291(%r8,%rax,4), %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x00,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addb	%bl, 291(%r8,%rax,4), %cl
# CHECK: {evex}	addw	%dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x01,0xd0]
         {evex}	addw	%dx, %ax
# CHECK: {nf}	addw	%dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x01,0xd0]
         {nf}	addw	%dx, %ax
# CHECK: addw	%dx, %ax, %r9w
# CHECK: encoding: [0x62,0xf4,0x35,0x18,0x01,0xd0]
         addw	%dx, %ax, %r9w
# CHECK: {nf}	addw	%dx, %ax, %r9w
# CHECK: encoding: [0x62,0xf4,0x35,0x1c,0x01,0xd0]
         {nf}	addw	%dx, %ax, %r9w
# CHECK: {evex}	addw	%dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x01,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	addw	%dx, 291(%r8,%rax,4)
# CHECK: {nf}	addw	%dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x01,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	addw	%dx, 291(%r8,%rax,4)
# CHECK: addw	%dx, 291(%r8,%rax,4), %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x01,0x94,0x80,0x23,0x01,0x00,0x00]
         addw	%dx, 291(%r8,%rax,4), %ax
# CHECK: {nf}	addw	%dx, 291(%r8,%rax,4), %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x01,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	addw	%dx, 291(%r8,%rax,4), %ax
# CHECK: {evex}	addl	%ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x01,0xca]
         {evex}	addl	%ecx, %edx
# CHECK: {nf}	addl	%ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x01,0xca]
         {nf}	addl	%ecx, %edx
# CHECK: addl	%ecx, %edx, %r10d
# CHECK: encoding: [0x62,0xf4,0x2c,0x18,0x01,0xca]
         addl	%ecx, %edx, %r10d
# CHECK: {nf}	addl	%ecx, %edx, %r10d
# CHECK: encoding: [0x62,0xf4,0x2c,0x1c,0x01,0xca]
         {nf}	addl	%ecx, %edx, %r10d
# CHECK: {evex}	addl	%ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x01,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	addl	%ecx, 291(%r8,%rax,4)
# CHECK: {nf}	addl	%ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x01,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addl	%ecx, 291(%r8,%rax,4)
# CHECK: addl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x01,0x8c,0x80,0x23,0x01,0x00,0x00]
         addl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: {nf}	addl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x01,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: {evex}	addq	%r9, %r15
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x01,0xcf]
         {evex}	addq	%r9, %r15
# CHECK: {nf}	addq	%r9, %r15
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x01,0xcf]
         {nf}	addq	%r9, %r15
# CHECK: addq	%r9, %r15, %r11
# CHECK: encoding: [0x62,0x54,0xa4,0x18,0x01,0xcf]
         addq	%r9, %r15, %r11
# CHECK: {nf}	addq	%r9, %r15, %r11
# CHECK: encoding: [0x62,0x54,0xa4,0x1c,0x01,0xcf]
         {nf}	addq	%r9, %r15, %r11
# CHECK: {evex}	addq	%r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x01,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	addq	%r9, 291(%r8,%rax,4)
# CHECK: {nf}	addq	%r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x01,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addq	%r9, 291(%r8,%rax,4)
# CHECK: addq	%r9, 291(%r8,%rax,4), %r15
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x01,0x8c,0x80,0x23,0x01,0x00,0x00]
         addq	%r9, 291(%r8,%rax,4), %r15
# CHECK: {nf}	addq	%r9, 291(%r8,%rax,4), %r15
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x01,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addq	%r9, 291(%r8,%rax,4), %r15
# CHECK: {evex}	addb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x02,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	addb	291(%r8,%rax,4), %bl
# CHECK: {nf}	addb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x02,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addb	291(%r8,%rax,4), %bl
# CHECK: addb	291(%r8,%rax,4), %bl, %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x02,0x9c,0x80,0x23,0x01,0x00,0x00]
         addb	291(%r8,%rax,4), %bl, %cl
# CHECK: {nf}	addb	291(%r8,%rax,4), %bl, %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x02,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addb	291(%r8,%rax,4), %bl, %cl
# CHECK: {evex}	addw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x03,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	addw	291(%r8,%rax,4), %dx
# CHECK: {nf}	addw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x03,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	addw	291(%r8,%rax,4), %dx
# CHECK: addw	291(%r8,%rax,4), %dx, %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x03,0x94,0x80,0x23,0x01,0x00,0x00]
         addw	291(%r8,%rax,4), %dx, %ax
# CHECK: {nf}	addw	291(%r8,%rax,4), %dx, %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x03,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	addw	291(%r8,%rax,4), %dx, %ax
# CHECK: {evex}	addl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x03,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	addl	291(%r8,%rax,4), %ecx
# CHECK: {nf}	addl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x03,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addl	291(%r8,%rax,4), %ecx
# CHECK: addl	291(%r8,%rax,4), %ecx, %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x03,0x8c,0x80,0x23,0x01,0x00,0x00]
         addl	291(%r8,%rax,4), %ecx, %edx
# CHECK: {nf}	addl	291(%r8,%rax,4), %ecx, %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x03,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addl	291(%r8,%rax,4), %ecx, %edx
# CHECK: {evex}	addq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x03,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	addq	291(%r8,%rax,4), %r9
# CHECK: {nf}	addq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x03,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addq	291(%r8,%rax,4), %r9
# CHECK: addq	291(%r8,%rax,4), %r9, %r15
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x03,0x8c,0x80,0x23,0x01,0x00,0x00]
         addq	291(%r8,%rax,4), %r9, %r15
# CHECK: {nf}	addq	291(%r8,%rax,4), %r9, %r15
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x03,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	addq	291(%r8,%rax,4), %r9, %r15
