# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-32: error:
# ERROR-NOT: error:
# CHECK: {evex}	decb	%bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xfe,0xcb]
         {evex}	decb	%bl
# CHECK: {nf}	decb	%bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xfe,0xcb]
         {nf}	decb	%bl
# CHECK: decb	%bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xfe,0xcb]
         decb	%bl, %bl
# CHECK: {nf}	decb	%bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xfe,0xcb]
         {nf}	decb	%bl, %bl
# CHECK: {evex}	decw	%dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xff,0xca]
         {evex}	decw	%dx
# CHECK: {nf}	decw	%dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xff,0xca]
         {nf}	decw	%dx
# CHECK: decw	%dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xff,0xca]
         decw	%dx, %dx
# CHECK: {nf}	decw	%dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xff,0xca]
         {nf}	decw	%dx, %dx
# CHECK: {evex}	decl	%ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xff,0xc9]
         {evex}	decl	%ecx
# CHECK: {nf}	decl	%ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xff,0xc9]
         {nf}	decl	%ecx
# CHECK: decl	%ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xff,0xc9]
         decl	%ecx, %ecx
# CHECK: {nf}	decl	%ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xff,0xc9]
         {nf}	decl	%ecx, %ecx
# CHECK: {evex}	decq	%r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xff,0xc9]
         {evex}	decq	%r9
# CHECK: {nf}	decq	%r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xff,0xc9]
         {nf}	decq	%r9
# CHECK: decq	%r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xff,0xc9]
         decq	%r9, %r9
# CHECK: {nf}	decq	%r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xff,0xc9]
         {nf}	decq	%r9, %r9
# CHECK: {evex}	decb	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xfe,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	decb	291(%r8,%rax,4)
# CHECK: {nf}	decb	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xfe,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	decb	291(%r8,%rax,4)
# CHECK: decb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xfe,0x8c,0x80,0x23,0x01,0x00,0x00]
         decb	291(%r8,%rax,4), %bl
# CHECK: {nf}	decb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xfe,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	decb	291(%r8,%rax,4), %bl
# CHECK: {evex}	decw	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	decw	291(%r8,%rax,4)
# CHECK: {nf}	decw	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	decw	291(%r8,%rax,4)
# CHECK: decw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         decw	291(%r8,%rax,4), %dx
# CHECK: {nf}	decw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	decw	291(%r8,%rax,4), %dx
# CHECK: {evex}	decl	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	decl	291(%r8,%rax,4)
# CHECK: {nf}	decl	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	decl	291(%r8,%rax,4)
# CHECK: decl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         decl	291(%r8,%rax,4), %ecx
# CHECK: {nf}	decl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	decl	291(%r8,%rax,4), %ecx
# CHECK: {evex}	decq	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	decq	291(%r8,%rax,4)
# CHECK: {nf}	decq	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	decq	291(%r8,%rax,4)
# CHECK: decq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         decq	291(%r8,%rax,4), %r9
# CHECK: {nf}	decq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xff,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	decq	291(%r8,%rax,4), %r9
