# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-32: error:
# ERROR-NOT: error:
# CHECK: {evex}	incb	%bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xfe,0xc3]
         {evex}	incb	%bl
# CHECK: {nf}	incb	%bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xfe,0xc3]
         {nf}	incb	%bl
# CHECK: incb	%bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xfe,0xc3]
         incb	%bl, %bl
# CHECK: {nf}	incb	%bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xfe,0xc3]
         {nf}	incb	%bl, %bl
# CHECK: {evex}	incw	%dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xff,0xc2]
         {evex}	incw	%dx
# CHECK: {nf}	incw	%dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xff,0xc2]
         {nf}	incw	%dx
# CHECK: incw	%dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xff,0xc2]
         incw	%dx, %dx
# CHECK: {nf}	incw	%dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xff,0xc2]
         {nf}	incw	%dx, %dx
# CHECK: {evex}	incl	%ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xff,0xc1]
         {evex}	incl	%ecx
# CHECK: {nf}	incl	%ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xff,0xc1]
         {nf}	incl	%ecx
# CHECK: incl	%ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xff,0xc1]
         incl	%ecx, %ecx
# CHECK: {nf}	incl	%ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xff,0xc1]
         {nf}	incl	%ecx, %ecx
# CHECK: {evex}	incq	%r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xff,0xc1]
         {evex}	incq	%r9
# CHECK: {nf}	incq	%r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xff,0xc1]
         {nf}	incq	%r9
# CHECK: incq	%r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xff,0xc1]
         incq	%r9, %r9
# CHECK: {nf}	incq	%r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xff,0xc1]
         {nf}	incq	%r9, %r9
# CHECK: {evex}	incb	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xfe,0x84,0x80,0x23,0x01,0x00,0x00]
         {evex}	incb	291(%r8,%rax,4)
# CHECK: {nf}	incb	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xfe,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	incb	291(%r8,%rax,4)
# CHECK: incb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xfe,0x84,0x80,0x23,0x01,0x00,0x00]
         incb	291(%r8,%rax,4), %bl
# CHECK: {nf}	incb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xfe,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	incb	291(%r8,%rax,4), %bl
# CHECK: {evex}	incw	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {evex}	incw	291(%r8,%rax,4)
# CHECK: {nf}	incw	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	incw	291(%r8,%rax,4)
# CHECK: incw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         incw	291(%r8,%rax,4), %dx
# CHECK: {nf}	incw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	incw	291(%r8,%rax,4), %dx
# CHECK: {evex}	incl	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {evex}	incl	291(%r8,%rax,4)
# CHECK: {nf}	incl	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	incl	291(%r8,%rax,4)
# CHECK: incl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         incl	291(%r8,%rax,4), %ecx
# CHECK: {nf}	incl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	incl	291(%r8,%rax,4), %ecx
# CHECK: {evex}	incq	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {evex}	incq	291(%r8,%rax,4)
# CHECK: {nf}	incq	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	incq	291(%r8,%rax,4)
# CHECK: incq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         incq	291(%r8,%rax,4), %r9
# CHECK: {nf}	incq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	incq	291(%r8,%rax,4), %r9
