# RUN: llvm-mc -triple x86_64 -show-encoding -x86-asm-syntax=intel -output-asm-variant=1 %s | FileCheck %s

# CHECK: {evex}	inc	bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xfe,0xc3]
         {evex}	inc	bl
# CHECK: {nf}	inc	bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xfe,0xc3]
         {nf}	inc	bl
# CHECK: inc	bl, bl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xfe,0xc3]
         inc	bl, bl
# CHECK: {nf}	inc	bl, bl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xfe,0xc3]
         {nf}	inc	bl, bl
# CHECK: {evex}	inc	dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xff,0xc2]
         {evex}	inc	dx
# CHECK: {nf}	inc	dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xff,0xc2]
         {nf}	inc	dx
# CHECK: inc	dx, dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xff,0xc2]
         inc	dx, dx
# CHECK: {nf}	inc	dx, dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xff,0xc2]
         {nf}	inc	dx, dx
# CHECK: {evex}	inc	ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xff,0xc1]
         {evex}	inc	ecx
# CHECK: {nf}	inc	ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xff,0xc1]
         {nf}	inc	ecx
# CHECK: inc	ecx, ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xff,0xc1]
         inc	ecx, ecx
# CHECK: {nf}	inc	ecx, ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xff,0xc1]
         {nf}	inc	ecx, ecx
# CHECK: {evex}	inc	r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xff,0xc1]
         {evex}	inc	r9
# CHECK: {nf}	inc	r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xff,0xc1]
         {nf}	inc	r9
# CHECK: inc	r9, r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xff,0xc1]
         inc	r9, r9
# CHECK: {nf}	inc	r9, r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xff,0xc1]
         {nf}	inc	r9, r9
# CHECK: {evex}	inc	byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xfe,0x84,0x80,0x23,0x01,0x00,0x00]
         {evex}	inc	byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	inc	byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xfe,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	inc	byte ptr [r8 + 4*rax + 291]
# CHECK: inc	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xfe,0x84,0x80,0x23,0x01,0x00,0x00]
         inc	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	inc	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xfe,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	inc	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {evex}	inc	word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {evex}	inc	word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	inc	word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	inc	word ptr [r8 + 4*rax + 291]
# CHECK: inc	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         inc	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	inc	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	inc	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {evex}	inc	dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {evex}	inc	dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	inc	dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	inc	dword ptr [r8 + 4*rax + 291]
# CHECK: inc	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         inc	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	inc	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	inc	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {evex}	inc	qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {evex}	inc	qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	inc	qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	inc	qword ptr [r8 + 4*rax + 291]
# CHECK: inc	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         inc	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	inc	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xff,0x84,0x80,0x23,0x01,0x00,0x00]
         {nf}	inc	r9, qword ptr [r8 + 4*rax + 291]
