# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-48: error:
# ERROR-NOT: error:
# CHECK: {evex}	shldw	$123, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x24,0xd2,0x7b]
         {evex}	shldw	$123, %dx, %dx
# CHECK: {nf}	shldw	$123, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x24,0xd2,0x7b]
         {nf}	shldw	$123, %dx, %dx
# CHECK: shldw	$123, %dx, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0x24,0xd2,0x7b]
         shldw	$123, %dx, %dx, %dx
# CHECK: {nf}	shldw	$123, %dx, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0x24,0xd2,0x7b]
         {nf}	shldw	$123, %dx, %dx, %dx
# CHECK: {evex}	shldw	$123, %dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x24,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shldw	$123, %dx, 291(%r8,%rax,4)
# CHECK: {nf}	shldw	$123, %dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x24,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shldw	$123, %dx, 291(%r8,%rax,4)
# CHECK: shldw	$123, %dx, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x24,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         shldw	$123, %dx, 291(%r8,%rax,4), %dx
# CHECK: {nf}	shldw	$123, %dx, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x24,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shldw	$123, %dx, 291(%r8,%rax,4), %dx
# CHECK: {evex}	shldl	$123, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x24,0xc9,0x7b]
         {evex}	shldl	$123, %ecx, %ecx
# CHECK: {nf}	shldl	$123, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x24,0xc9,0x7b]
         {nf}	shldl	$123, %ecx, %ecx
# CHECK: shldl	$123, %ecx, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0x24,0xc9,0x7b]
         shldl	$123, %ecx, %ecx, %ecx
# CHECK: {nf}	shldl	$123, %ecx, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0x24,0xc9,0x7b]
         {nf}	shldl	$123, %ecx, %ecx, %ecx
# CHECK: {evex}	shldl	$123, %ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x24,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shldl	$123, %ecx, 291(%r8,%rax,4)
# CHECK: {nf}	shldl	$123, %ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x24,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shldl	$123, %ecx, 291(%r8,%rax,4)
# CHECK: shldl	$123, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x24,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         shldl	$123, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	shldl	$123, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x24,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shldl	$123, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	shldq	$123, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x24,0xc9,0x7b]
         {evex}	shldq	$123, %r9, %r9
# CHECK: {nf}	shldq	$123, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x24,0xc9,0x7b]
         {nf}	shldq	$123, %r9, %r9
# CHECK: shldq	$123, %r9, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x18,0x24,0xc9,0x7b]
         shldq	$123, %r9, %r9, %r9
# CHECK: {nf}	shldq	$123, %r9, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x1c,0x24,0xc9,0x7b]
         {nf}	shldq	$123, %r9, %r9, %r9
# CHECK: {evex}	shldq	$123, %r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x24,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shldq	$123, %r9, 291(%r8,%rax,4)
# CHECK: {nf}	shldq	$123, %r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x24,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shldq	$123, %r9, 291(%r8,%rax,4)
# CHECK: shldq	$123, %r9, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x18,0x24,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         shldq	$123, %r9, 291(%r8,%rax,4), %r9
# CHECK: {nf}	shldq	$123, %r9, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x1c,0x24,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shldq	$123, %r9, 291(%r8,%rax,4), %r9
# CHECK: {evex}	shldw	%cl, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xa5,0xd2]
         {evex}	shldw	%cl, %dx, %dx
# CHECK: {nf}	shldw	%cl, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xa5,0xd2]
         {nf}	shldw	%cl, %dx, %dx
# CHECK: shldw	%cl, %dx, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xa5,0xd2]
         shldw	%cl, %dx, %dx, %dx
# CHECK: {nf}	shldw	%cl, %dx, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xa5,0xd2]
         {nf}	shldw	%cl, %dx, %dx, %dx
# CHECK: {evex}	shldw	%cl, %dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xa5,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	shldw	%cl, %dx, 291(%r8,%rax,4)
# CHECK: {nf}	shldw	%cl, %dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xa5,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	shldw	%cl, %dx, 291(%r8,%rax,4)
# CHECK: shldw	%cl, %dx, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xa5,0x94,0x80,0x23,0x01,0x00,0x00]
         shldw	%cl, %dx, 291(%r8,%rax,4), %dx
# CHECK: {nf}	shldw	%cl, %dx, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xa5,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	shldw	%cl, %dx, 291(%r8,%rax,4), %dx
# CHECK: {evex}	shldl	%cl, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xa5,0xc9]
         {evex}	shldl	%cl, %ecx, %ecx
# CHECK: {nf}	shldl	%cl, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xa5,0xc9]
         {nf}	shldl	%cl, %ecx, %ecx
# CHECK: shldl	%cl, %ecx, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xa5,0xc9]
         shldl	%cl, %ecx, %ecx, %ecx
# CHECK: {nf}	shldl	%cl, %ecx, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xa5,0xc9]
         {nf}	shldl	%cl, %ecx, %ecx, %ecx
# CHECK: {evex}	shldl	%cl, %ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xa5,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	shldl	%cl, %ecx, 291(%r8,%rax,4)
# CHECK: {nf}	shldl	%cl, %ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xa5,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	shldl	%cl, %ecx, 291(%r8,%rax,4)
# CHECK: shldl	%cl, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xa5,0x8c,0x80,0x23,0x01,0x00,0x00]
         shldl	%cl, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	shldl	%cl, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xa5,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	shldl	%cl, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	shldq	%cl, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0xa5,0xc9]
         {evex}	shldq	%cl, %r9, %r9
# CHECK: {nf}	shldq	%cl, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0xa5,0xc9]
         {nf}	shldq	%cl, %r9, %r9
# CHECK: shldq	%cl, %r9, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x18,0xa5,0xc9]
         shldq	%cl, %r9, %r9, %r9
# CHECK: {nf}	shldq	%cl, %r9, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x1c,0xa5,0xc9]
         {nf}	shldq	%cl, %r9, %r9, %r9
# CHECK: {evex}	shldq	%cl, %r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0xa5,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	shldq	%cl, %r9, 291(%r8,%rax,4)
# CHECK: {nf}	shldq	%cl, %r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0xa5,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	shldq	%cl, %r9, 291(%r8,%rax,4)
# CHECK: shldq	%cl, %r9, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x18,0xa5,0x8c,0x80,0x23,0x01,0x00,0x00]
         shldq	%cl, %r9, 291(%r8,%rax,4), %r9
# CHECK: {nf}	shldq	%cl, %r9, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x1c,0xa5,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	shldq	%cl, %r9, 291(%r8,%rax,4), %r9
