# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-48: error:
# ERROR-NOT: error:
# CHECK: {evex}	shrdw	$123, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x2c,0xd2,0x7b]
         {evex}	shrdw	$123, %dx, %dx
# CHECK: {nf}	shrdw	$123, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x2c,0xd2,0x7b]
         {nf}	shrdw	$123, %dx, %dx
# CHECK: shrdw	$123, %dx, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0x2c,0xd2,0x7b]
         shrdw	$123, %dx, %dx, %dx
# CHECK: {nf}	shrdw	$123, %dx, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0x2c,0xd2,0x7b]
         {nf}	shrdw	$123, %dx, %dx, %dx
# CHECK: {evex}	shrdw	$123, %dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x2c,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shrdw	$123, %dx, 291(%r8,%rax,4)
# CHECK: {nf}	shrdw	$123, %dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x2c,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrdw	$123, %dx, 291(%r8,%rax,4)
# CHECK: shrdw	$123, %dx, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x2c,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         shrdw	$123, %dx, 291(%r8,%rax,4), %dx
# CHECK: {nf}	shrdw	$123, %dx, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x2c,0x94,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrdw	$123, %dx, 291(%r8,%rax,4), %dx
# CHECK: {evex}	shrdl	$123, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x2c,0xc9,0x7b]
         {evex}	shrdl	$123, %ecx, %ecx
# CHECK: {nf}	shrdl	$123, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x2c,0xc9,0x7b]
         {nf}	shrdl	$123, %ecx, %ecx
# CHECK: shrdl	$123, %ecx, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0x2c,0xc9,0x7b]
         shrdl	$123, %ecx, %ecx, %ecx
# CHECK: {nf}	shrdl	$123, %ecx, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0x2c,0xc9,0x7b]
         {nf}	shrdl	$123, %ecx, %ecx, %ecx
# CHECK: {evex}	shrdl	$123, %ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x2c,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shrdl	$123, %ecx, 291(%r8,%rax,4)
# CHECK: {nf}	shrdl	$123, %ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x2c,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrdl	$123, %ecx, 291(%r8,%rax,4)
# CHECK: shrdl	$123, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x2c,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         shrdl	$123, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	shrdl	$123, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x2c,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrdl	$123, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	shrdq	$123, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x2c,0xc9,0x7b]
         {evex}	shrdq	$123, %r9, %r9
# CHECK: {nf}	shrdq	$123, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x2c,0xc9,0x7b]
         {nf}	shrdq	$123, %r9, %r9
# CHECK: shrdq	$123, %r9, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x18,0x2c,0xc9,0x7b]
         shrdq	$123, %r9, %r9, %r9
# CHECK: {nf}	shrdq	$123, %r9, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x1c,0x2c,0xc9,0x7b]
         {nf}	shrdq	$123, %r9, %r9, %r9
# CHECK: {evex}	shrdq	$123, %r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x2c,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shrdq	$123, %r9, 291(%r8,%rax,4)
# CHECK: {nf}	shrdq	$123, %r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x2c,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrdq	$123, %r9, 291(%r8,%rax,4)
# CHECK: shrdq	$123, %r9, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x18,0x2c,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         shrdq	$123, %r9, 291(%r8,%rax,4), %r9
# CHECK: {nf}	shrdq	$123, %r9, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x1c,0x2c,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrdq	$123, %r9, 291(%r8,%rax,4), %r9
# CHECK: {evex}	shrdw	%cl, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xad,0xd2]
         {evex}	shrdw	%cl, %dx, %dx
# CHECK: {nf}	shrdw	%cl, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xad,0xd2]
         {nf}	shrdw	%cl, %dx, %dx
# CHECK: shrdw	%cl, %dx, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xad,0xd2]
         shrdw	%cl, %dx, %dx, %dx
# CHECK: {nf}	shrdw	%cl, %dx, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xad,0xd2]
         {nf}	shrdw	%cl, %dx, %dx, %dx
# CHECK: {evex}	shrdw	%cl, %dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xad,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrdw	%cl, %dx, 291(%r8,%rax,4)
# CHECK: {nf}	shrdw	%cl, %dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xad,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrdw	%cl, %dx, 291(%r8,%rax,4)
# CHECK: shrdw	%cl, %dx, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xad,0x94,0x80,0x23,0x01,0x00,0x00]
         shrdw	%cl, %dx, 291(%r8,%rax,4), %dx
# CHECK: {nf}	shrdw	%cl, %dx, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xad,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrdw	%cl, %dx, 291(%r8,%rax,4), %dx
# CHECK: {evex}	shrdl	%cl, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xad,0xc9]
         {evex}	shrdl	%cl, %ecx, %ecx
# CHECK: {nf}	shrdl	%cl, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xad,0xc9]
         {nf}	shrdl	%cl, %ecx, %ecx
# CHECK: shrdl	%cl, %ecx, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xad,0xc9]
         shrdl	%cl, %ecx, %ecx, %ecx
# CHECK: {nf}	shrdl	%cl, %ecx, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xad,0xc9]
         {nf}	shrdl	%cl, %ecx, %ecx, %ecx
# CHECK: {evex}	shrdl	%cl, %ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xad,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrdl	%cl, %ecx, 291(%r8,%rax,4)
# CHECK: {nf}	shrdl	%cl, %ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xad,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrdl	%cl, %ecx, 291(%r8,%rax,4)
# CHECK: shrdl	%cl, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xad,0x8c,0x80,0x23,0x01,0x00,0x00]
         shrdl	%cl, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	shrdl	%cl, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xad,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrdl	%cl, %ecx, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	shrdq	%cl, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0xad,0xc9]
         {evex}	shrdq	%cl, %r9, %r9
# CHECK: {nf}	shrdq	%cl, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0xad,0xc9]
         {nf}	shrdq	%cl, %r9, %r9
# CHECK: shrdq	%cl, %r9, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x18,0xad,0xc9]
         shrdq	%cl, %r9, %r9, %r9
# CHECK: {nf}	shrdq	%cl, %r9, %r9, %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x1c,0xad,0xc9]
         {nf}	shrdq	%cl, %r9, %r9, %r9
# CHECK: {evex}	shrdq	%cl, %r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0xad,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrdq	%cl, %r9, 291(%r8,%rax,4)
# CHECK: {nf}	shrdq	%cl, %r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0xad,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrdq	%cl, %r9, 291(%r8,%rax,4)
# CHECK: shrdq	%cl, %r9, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x18,0xad,0x8c,0x80,0x23,0x01,0x00,0x00]
         shrdq	%cl, %r9, 291(%r8,%rax,4), %r9
# CHECK: {nf}	shrdq	%cl, %r9, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xb4,0x1c,0xad,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrdq	%cl, %r9, 291(%r8,%rax,4), %r9
