# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-104: error:
# ERROR-NOT: error:
# CHECK: {evex}	subb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x80,0xeb,0x7b]
         {evex}	subb	$123, %bl
# CHECK: {nf}	subb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x80,0xeb,0x7b]
         {nf}	subb	$123, %bl
# CHECK: subb	$123, %bl, %cl
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0x80,0xeb,0x7b]
         subb	$123, %bl, %cl
# CHECK: {nf}	subb	$123, %bl, %cl
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0x80,0xeb,0x7b]
         {nf}	subb	$123, %bl, %cl
# CHECK: {evex}	subw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x83,0xea,0x7b]
         {evex}	subw	$123, %dx
# CHECK: {nf}	subw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x83,0xea,0x7b]
         {nf}	subw	$123, %dx
# CHECK: subw	$123, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x83,0xea,0x7b]
         subw	$123, %dx, %ax
# CHECK: {nf}	subw	$123, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x83,0xea,0x7b]
         {nf}	subw	$123, %dx, %ax
# CHECK: {evex}	subl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x83,0xe9,0x7b]
         {evex}	subl	$123, %ecx
# CHECK: {nf}	subl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x83,0xe9,0x7b]
         {nf}	subl	$123, %ecx
# CHECK: subl	$123, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x83,0xe9,0x7b]
         subl	$123, %ecx, %edx
# CHECK: {nf}	subl	$123, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x83,0xe9,0x7b]
         {nf}	subl	$123, %ecx, %edx
# CHECK: {evex}	subq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xe9,0x7b]
         {evex}	subq	$123, %r9
# CHECK: {nf}	subq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xe9,0x7b]
         {nf}	subq	$123, %r9
# CHECK: subq	$123, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x83,0xe9,0x7b]
         subq	$123, %r9, %r15
# CHECK: {nf}	subq	$123, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x83,0xe9,0x7b]
         {nf}	subq	$123, %r9, %r15
# CHECK: {evex}	subb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x80,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	subb	$123, 291(%r8,%rax,4)
# CHECK: {nf}	subb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x80,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	subb	$123, 291(%r8,%rax,4)
# CHECK: subb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0x80,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         subb	$123, 291(%r8,%rax,4), %bl
# CHECK: {nf}	subb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0x80,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	subb	$123, 291(%r8,%rax,4), %bl
# CHECK: {evex}	subw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	subw	$123, 291(%r8,%rax,4)
# CHECK: {nf}	subw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	subw	$123, 291(%r8,%rax,4)
# CHECK: subw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         subw	$123, 291(%r8,%rax,4), %dx
# CHECK: {nf}	subw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	subw	$123, 291(%r8,%rax,4), %dx
# CHECK: {evex}	subl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	subl	$123, 291(%r8,%rax,4)
# CHECK: {nf}	subl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	subl	$123, 291(%r8,%rax,4)
# CHECK: subl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         subl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	subl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	subl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	subq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	subq	$123, 291(%r8,%rax,4)
# CHECK: {nf}	subq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	subq	$123, 291(%r8,%rax,4)
# CHECK: subq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         subq	$123, 291(%r8,%rax,4), %r9
# CHECK: {nf}	subq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x83,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	subq	$123, 291(%r8,%rax,4), %r9
# CHECK: {evex}	subw	$1234, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x81,0xea,0xd2,0x04]
         {evex}	subw	$1234, %dx
# CHECK: {nf}	subw	$1234, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x81,0xea,0xd2,0x04]
         {nf}	subw	$1234, %dx
# CHECK: subw	$1234, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x81,0xea,0xd2,0x04]
         subw	$1234, %dx, %ax
# CHECK: {nf}	subw	$1234, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x81,0xea,0xd2,0x04]
         {nf}	subw	$1234, %dx, %ax
# CHECK: {evex}	subw	$1234, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {evex}	subw	$1234, 291(%r8,%rax,4)
# CHECK: {nf}	subw	$1234, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	subw	$1234, 291(%r8,%rax,4)
# CHECK: subw	$1234, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         subw	$1234, 291(%r8,%rax,4), %dx
# CHECK: {nf}	subw	$1234, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	subw	$1234, 291(%r8,%rax,4), %dx
# CHECK: {evex}	subl	$123456, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x81,0xe9,0x40,0xe2,0x01,0x00]
         {evex}	subl	$123456, %ecx
# CHECK: {nf}	subl	$123456, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x81,0xe9,0x40,0xe2,0x01,0x00]
         {nf}	subl	$123456, %ecx
# CHECK: subl	$123456, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x81,0xe9,0x40,0xe2,0x01,0x00]
         subl	$123456, %ecx, %edx
# CHECK: {nf}	subl	$123456, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x81,0xe9,0x40,0xe2,0x01,0x00]
         {nf}	subl	$123456, %ecx, %edx
# CHECK: {evex}	subq	$123456, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xe9,0x40,0xe2,0x01,0x00]
         {evex}	subq	$123456, %r9
# CHECK: {nf}	subq	$123456, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xe9,0x40,0xe2,0x01,0x00]
         {nf}	subq	$123456, %r9
# CHECK: subq	$123456, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x81,0xe9,0x40,0xe2,0x01,0x00]
         subq	$123456, %r9, %r15
# CHECK: {nf}	subq	$123456, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x81,0xe9,0x40,0xe2,0x01,0x00]
         {nf}	subq	$123456, %r9, %r15
# CHECK: {evex}	subl	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	subl	$123456, 291(%r8,%rax,4)
# CHECK: {nf}	subl	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	subl	$123456, 291(%r8,%rax,4)
# CHECK: subl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         subl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	subl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	subl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	subq	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	subq	$123456, 291(%r8,%rax,4)
# CHECK: {nf}	subq	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	subq	$123456, 291(%r8,%rax,4)
# CHECK: subq	$123456, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         subq	$123456, 291(%r8,%rax,4), %r9
# CHECK: {nf}	subq	$123456, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x81,0xac,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	subq	$123456, 291(%r8,%rax,4), %r9
# CHECK: {evex}	subb	%bl, %cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x28,0xd9]
         {evex}	subb	%bl, %cl
# CHECK: {nf}	subb	%bl, %cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x28,0xd9]
         {nf}	subb	%bl, %cl
# CHECK: subb	%bl, %cl, %r8b
# CHECK: encoding: [0x62,0xf4,0x3c,0x18,0x28,0xd9]
         subb	%bl, %cl, %r8b
# CHECK: {nf}	subb	%bl, %cl, %r8b
# CHECK: encoding: [0x62,0xf4,0x3c,0x1c,0x28,0xd9]
         {nf}	subb	%bl, %cl, %r8b
# CHECK: {evex}	subb	%bl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x28,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	subb	%bl, 291(%r8,%rax,4)
# CHECK: {nf}	subb	%bl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x28,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subb	%bl, 291(%r8,%rax,4)
# CHECK: subb	%bl, 291(%r8,%rax,4), %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x28,0x9c,0x80,0x23,0x01,0x00,0x00]
         subb	%bl, 291(%r8,%rax,4), %cl
# CHECK: {nf}	subb	%bl, 291(%r8,%rax,4), %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x28,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subb	%bl, 291(%r8,%rax,4), %cl
# CHECK: {evex}	subw	%dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x29,0xd0]
         {evex}	subw	%dx, %ax
# CHECK: {nf}	subw	%dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x29,0xd0]
         {nf}	subw	%dx, %ax
# CHECK: subw	%dx, %ax, %r9w
# CHECK: encoding: [0x62,0xf4,0x35,0x18,0x29,0xd0]
         subw	%dx, %ax, %r9w
# CHECK: {nf}	subw	%dx, %ax, %r9w
# CHECK: encoding: [0x62,0xf4,0x35,0x1c,0x29,0xd0]
         {nf}	subw	%dx, %ax, %r9w
# CHECK: {evex}	subw	%dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x29,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	subw	%dx, 291(%r8,%rax,4)
# CHECK: {nf}	subw	%dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x29,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	subw	%dx, 291(%r8,%rax,4)
# CHECK: subw	%dx, 291(%r8,%rax,4), %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x29,0x94,0x80,0x23,0x01,0x00,0x00]
         subw	%dx, 291(%r8,%rax,4), %ax
# CHECK: {nf}	subw	%dx, 291(%r8,%rax,4), %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x29,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	subw	%dx, 291(%r8,%rax,4), %ax
# CHECK: {evex}	subl	%ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x29,0xca]
         {evex}	subl	%ecx, %edx
# CHECK: {nf}	subl	%ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x29,0xca]
         {nf}	subl	%ecx, %edx
# CHECK: subl	%ecx, %edx, %r10d
# CHECK: encoding: [0x62,0xf4,0x2c,0x18,0x29,0xca]
         subl	%ecx, %edx, %r10d
# CHECK: {nf}	subl	%ecx, %edx, %r10d
# CHECK: encoding: [0x62,0xf4,0x2c,0x1c,0x29,0xca]
         {nf}	subl	%ecx, %edx, %r10d
# CHECK: {evex}	subl	%ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x29,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	subl	%ecx, 291(%r8,%rax,4)
# CHECK: {nf}	subl	%ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x29,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subl	%ecx, 291(%r8,%rax,4)
# CHECK: subl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x29,0x8c,0x80,0x23,0x01,0x00,0x00]
         subl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: {nf}	subl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x29,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: {evex}	subq	%r9, %r15
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x29,0xcf]
         {evex}	subq	%r9, %r15
# CHECK: {nf}	subq	%r9, %r15
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x29,0xcf]
         {nf}	subq	%r9, %r15
# CHECK: subq	%r9, %r15, %r11
# CHECK: encoding: [0x62,0x54,0xa4,0x18,0x29,0xcf]
         subq	%r9, %r15, %r11
# CHECK: {nf}	subq	%r9, %r15, %r11
# CHECK: encoding: [0x62,0x54,0xa4,0x1c,0x29,0xcf]
         {nf}	subq	%r9, %r15, %r11
# CHECK: {evex}	subq	%r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x29,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	subq	%r9, 291(%r8,%rax,4)
# CHECK: {nf}	subq	%r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x29,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subq	%r9, 291(%r8,%rax,4)
# CHECK: subq	%r9, 291(%r8,%rax,4), %r15
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x29,0x8c,0x80,0x23,0x01,0x00,0x00]
         subq	%r9, 291(%r8,%rax,4), %r15
# CHECK: {nf}	subq	%r9, 291(%r8,%rax,4), %r15
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x29,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subq	%r9, 291(%r8,%rax,4), %r15
# CHECK: {evex}	subb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x2a,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	subb	291(%r8,%rax,4), %bl
# CHECK: {nf}	subb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x2a,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subb	291(%r8,%rax,4), %bl
# CHECK: subb	291(%r8,%rax,4), %bl, %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x2a,0x9c,0x80,0x23,0x01,0x00,0x00]
         subb	291(%r8,%rax,4), %bl, %cl
# CHECK: {nf}	subb	291(%r8,%rax,4), %bl, %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x2a,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subb	291(%r8,%rax,4), %bl, %cl
# CHECK: {evex}	subw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x2b,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	subw	291(%r8,%rax,4), %dx
# CHECK: {nf}	subw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x2b,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	subw	291(%r8,%rax,4), %dx
# CHECK: subw	291(%r8,%rax,4), %dx, %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x2b,0x94,0x80,0x23,0x01,0x00,0x00]
         subw	291(%r8,%rax,4), %dx, %ax
# CHECK: {nf}	subw	291(%r8,%rax,4), %dx, %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x2b,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	subw	291(%r8,%rax,4), %dx, %ax
# CHECK: {evex}	subl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x2b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	subl	291(%r8,%rax,4), %ecx
# CHECK: {nf}	subl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x2b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subl	291(%r8,%rax,4), %ecx
# CHECK: subl	291(%r8,%rax,4), %ecx, %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x2b,0x8c,0x80,0x23,0x01,0x00,0x00]
         subl	291(%r8,%rax,4), %ecx, %edx
# CHECK: {nf}	subl	291(%r8,%rax,4), %ecx, %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x2b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subl	291(%r8,%rax,4), %ecx, %edx
# CHECK: {evex}	subq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x2b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	subq	291(%r8,%rax,4), %r9
# CHECK: {nf}	subq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x2b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subq	291(%r8,%rax,4), %r9
# CHECK: subq	291(%r8,%rax,4), %r9, %r15
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x2b,0x8c,0x80,0x23,0x01,0x00,0x00]
         subq	291(%r8,%rax,4), %r9, %r15
# CHECK: {nf}	subq	291(%r8,%rax,4), %r9, %r15
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x2b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	subq	291(%r8,%rax,4), %r9, %r15
